#ifndef MW_HTML_PARSER_H
#define MW_HTML_PARSER_H

typedef struct MwHtmlNode {
	char *tag;		/* tag name */
	char *text;		/* text */
	struct MwHtmlNode *parent;	/* parent */
	struct MwHtmlNode *next;	/* next sibling */
	struct MwHtmlNode *child;	/* first child */
} MwHtmlNode;

#define MW_HTML_OBJECT 1	/* unused */
#define MW_HTML_BEGIN_A 2	/* <a> tag */
#define MW_HTML_END_A 3		/* </a> tag */
#define MW_HTML_IMAGE 4		/* <img> tag */
#define MW_HTML_HR 5		/* <hr> tag */
#define MW_HTML_WORDPART 6	/* word segment such as foo in foo<i>bar</i> */
#define MW_HTML_NEWLINE 7	/* line break for any reason */
#define MW_HTML_SPACE 8		/* word separator */
#define MW_HTML_INDENT 9	/* indentation level */
#define MW_HTML_UBULLET 10	/* unordered bullet */
#define MW_HTML_OBULLET 11	/* ordered bullet */
#define MW_HTML_TAB 12		/* table column separator */

typedef struct MwHtmlAnchor {
	char *href;
	char *name;
} MwHtmlAnchor;

typedef struct MwHtmlImage {
	char *src;
	char *alt;
} MwHtmlImage;

typedef struct object_box {
        int type;
        void *data;
	int x, y, w, h;
        struct object_box *next;
} object_box;

extern void MwHtmlDump(MwHtmlNode *h, int i);
extern char *MwHtmlGetValue(char *, char *);
extern void MwHtmlFree(object_box *);
extern object_box *MwHtmlParse(int (*getc_cb)(void *), void *);

extern void MwHtmlDumpTree(MwHtmlNode *, void *,
		int (*)(void *, int, int),
		void (*)(int, void *, void *));

#endif	/* MW_HTML_PARSER */
